
/* very simple app to set the tv frequency */

#include <sys/time.h>
#include <sys/types.h>
#include <asm/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <errno.h>
#include <linux/fs.h>
#include <linux/kernel.h>
#include <linux/videodev2.h>

int main(int argc,char **argv) {
  int vfd = 0;
  int arg;
  char *devname = "/dev/video";

  if( argc != 2 ) {
        puts("Usage: freq frequency\n");
        puts("  where frequency is in units of 62.5KHz\n");
        exit(1);
  }

  arg = atoi(argv[1]);
  vfd = open(devname,O_RDWR|O_NONCAP);
  if (vfd <= 0) {
    fprintf(stderr,"sorry, no such device %s\n",devname);
    exit(1);
  }

  if (ioctl(vfd,VIDIOC_S_FREQ,&arg) < 0)
    perror("setting frequency"),exit(1);
  close(vfd);
  return 0;
}
